package  
{
	import com.citrusengine.core.StarlingState;
	import com.citrusengine.objects.PhysicsObject;
	import com.citrusengine.objects.platformer.Platform;
	import com.citrusengine.physics.Box2D;
	
	import starling.display.Image;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.textures.Texture;
	
	/**
	 * ...
	 * @author Aymeric
	 */
	public class Box2DStarlingGameState extends StarlingState 
	{
		[Embed(source="../bin/small_crate.png")]
		private var _cratePng:Class;
		
		public function Box2DStarlingGameState() 
		{
			super();
		}
		
		override public function initialize():void {
			
			super.initialize();
			
			var box2D:Box2D = new Box2D("box2D");
			//box2D.visible = true;
			add(box2D);
			
			add(new Platform("borderBottom", { x:stage.stageWidth / 2, y:stage.stageHeight - 10, width:stage.stageWidth, height:10 } ));
			add(new Platform("borderLeft", { x:0, y:stage.stageHeight / 2, width:10, height:stage.stageHeight } ));
			add(new Platform("borderRight", { x:stage.stageWidth - 10, y:stage.stageHeight / 2, width:10, height:stage.stageHeight } ));
			
			stage.addEventListener(TouchEvent.TOUCH, _addObject);
		}
		
		private function _addObject(tEvt:TouchEvent):void {
			
			var touch:Touch = tEvt.getTouch(stage, TouchPhase.BEGAN);
			
			if (touch) {
				
				var image:Image = new Image(Texture.fromBitmap(new _cratePng()));
			
				var physicObject:PhysicsObject = new PhysicsObject("physicobject", { x:touch.getLocation(this).x, y:touch.getLocation(this).y, width:35, height:38, view:image} );
				add(physicObject);
			}
			
		}
		
	}

}